﻿// -------------------------------------------------------
// <autogenerated>
// This file was automatically generated with Reegenerator.
// Any changes made to this file will be removed when this file is regenerated.
// 
// Generator: OneAccomplishment.CodeGen.BusinessRules.RuleViolationsRenderer
// </autogenerated>
// -------------------------------------------------------


namespace OneAccomplishment.Core.BusinessRules.Violations
{
    using System;
    using System.Resources;
    using System.Threading;
    using Net40Utilities.Validation;
    
    /// <summary>
    /// A strongly-typed resource class, for looking up localized strings related
    /// to LoginViolations.
    /// </summary>
    public sealed partial class LoginViolations : AbstractRuleViolation<LoginViolations>
    {
            private static readonly Lazy<ResourceManager> CommonResourceManager = 
        new Lazy<ResourceManager>(
            () => new ResourceManager(
                "OneAccomplishment.Core.BusinessRules.Violations.CommonViolations",
                typeof(LoginViolations).Assembly),
            LazyThreadSafetyMode.ExecutionAndPublication);

            private static readonly Lazy<ResourceManager> ResourceManager = 
        new Lazy<ResourceManager>(
            () => new ResourceManager(
                "OneAccomplishment.Core.BusinessRules.Violations.LoginViolations",
                typeof(LoginViolations).Assembly),
            LazyThreadSafetyMode.ExecutionAndPublication);


        /// <summary>
        /// Resolves a LoginViolations value from a key.
        /// </summary>
        public static string ResolveKey(string key)
        {
            ArgumentGuard.For(() => key).IsNull().Throw();

            string value = CommonResourceManager.Value.GetString(key, null);
            if (value == null) {
                value = ResourceManager.Value.GetString(key, null);
            }
            return value;
        }
        
        private LoginViolations(string key)
            : base(key, CommonResourceManager.Value, ResourceManager.Value)
        {
        }

        public override bool Equals(object obj)
        {
            return base.Equals(obj);
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }

        public static bool operator ==(LoginViolations a, LoginViolations b)
        {
            return Object.Equals(a, b);
        }

        public static bool operator !=(LoginViolations a, LoginViolations b)
        {
            return !(a == b);
        }

        public static implicit operator string(LoginViolations instance)
        {
            return instance.ToString();
        }

        
    private static readonly Lazy<LoginViolations> MissingRequiredValueInstance = 
        new Lazy<LoginViolations>(
            () => new LoginViolations("MissingRequiredValue"),
            LazyThreadSafetyMode.ExecutionAndPublication);
                
    /// <summary>
    /// Purpose: [COMMON] When a required value is missing.
    /// <para>Gets a localized string similar to 'ERR_MISSING_REQ_VALUE'</para>
    /// </summary>
    public static LoginViolations MissingRequiredValue
    {
        get { return MissingRequiredValueInstance.Value; }
    }
    
    private static readonly Lazy<LoginViolations> CurrentAuthenticationInvalidInstance = 
        new Lazy<LoginViolations>(
            () => new LoginViolations("CurrentAuthenticationInvalid"),
            LazyThreadSafetyMode.ExecutionAndPublication);
                
    /// <summary>
    /// Purpose: When a logout is attempted but the current authentication ticket is invalid.
    /// <para>Gets a localized string similar to 'ERR_CURRENT_AUTHN_INVALID'</para>
    /// </summary>
    public static LoginViolations CurrentAuthenticationInvalid
    {
        get { return CurrentAuthenticationInvalidInstance.Value; }
    }
    
    private static readonly Lazy<LoginViolations> InvalidCredentialsInstance = 
        new Lazy<LoginViolations>(
            () => new LoginViolations("InvalidCredentials"),
            LazyThreadSafetyMode.ExecutionAndPublication);
                
    /// <summary>
    /// Purpose: When domain credential validation fails.
    /// <para>Gets a localized string similar to 'ERR_LOGIN_INVALID_CREDENTIALS'</para>
    /// </summary>
    public static LoginViolations InvalidCredentials
    {
        get { return InvalidCredentialsInstance.Value; }
    }
    
    private static readonly Lazy<LoginViolations> LoginAttemptExceededInstance = 
        new Lazy<LoginViolations>(
            () => new LoginViolations("LoginAttemptExceeded"),
            LazyThreadSafetyMode.ExecutionAndPublication);
                
    /// <summary>
    /// Purpose: When repeated failed login attempts are made.
    /// <para>Gets a localized string similar to 'ERR_LOGIN_ATTEMPT_EXCEEDED'</para>
    /// </summary>
    public static LoginViolations LoginAttemptExceeded
    {
        get { return LoginAttemptExceededInstance.Value; }
    }

    }
}
